##check if the max score has been reached

##ffa

execute if score .battle_mode general matches 1 as @a[tag=ingame] at @s if score @s score >= .battle_max_score general if score .battle_ending_timer general matches 0 run function tmls:functions/matchmaking/modes/ffa/stop


##team battle

execute if score .battle_mode general matches 2 if score Blue teamscore >= .battle_max_score general if score .battle_ending_timer general matches 0 run function tmls:functions/matchmaking/modes/team_battle/stop
execute if score .battle_mode general matches 2 if score Red teamscore >= .battle_max_score general if score .battle_ending_timer general matches 0 run function tmls:functions/matchmaking/modes/team_battle/stop


##gun game

execute if score .battle_mode general matches 3 as @a[tag=ingame] at @s if score @s score >= .battle_max_score general if score .battle_ending_timer general matches 0 run function tmls:functions/matchmaking/modes/gungame/stop


##capture the egg

execute if score .battle_mode general matches 4 run function tmls:functions/matchmaking/modes/capture_the_egg/main

execute if score .battle_mode general matches 4 if score Blue teamscore >= .battle_max_score general if score .battle_ending_timer general matches 0 run function tmls:functions/matchmaking/modes/capture_the_egg/stop
execute if score .battle_mode general matches 4 if score Red teamscore >= .battle_max_score general if score .battle_ending_timer general matches 0 run function tmls:functions/matchmaking/modes/capture_the_egg/stop


##infection

execute if score .battle_mode general matches 5 if score Survivors infection >= .battle_max_score general if score .battle_ending_timer general matches 0 run function tmls:functions/matchmaking/modes/undead_geese/stop
execute if score .battle_mode general matches 5 unless entity @a[tag=ingame,tag=!undead] if score .battle_ending_timer general matches 0 run function tmls:functions/matchmaking/modes/undead_geese/stop

execute if score .battle_mode general matches 5 run scoreboard players set Survivor infection 0
execute if score .battle_mode general matches 5 as @a[tag=ingame,tag=!undead] run scoreboard players add Survivor infection 1

execute if score .battle_mode general matches 5 run effect give @a[tag=ingame,tag=!undead] glowing 1 10 true 


##protect the statue

execute if score .battle_mode general matches 6 run function tmls:functions/matchmaking/modes/protect_the_statue/main

execute if score .battle_mode general matches 6 if score Blue teamscore matches -1000..0 if score .battle_ending_timer general matches 0 run function tmls:functions/matchmaking/modes/protect_the_statue/stop
execute if score .battle_mode general matches 6 if score Red teamscore matches -1000..0 if score .battle_ending_timer general matches 0 run function tmls:functions/matchmaking/modes/protect_the_statue/stop


##training

execute if score .battle_mode general matches 7 if score Blue training >= .battle_max_score general if score .battle_ending_timer general matches 0 run function tmls:functions/matchmaking/modes/training/stop
execute if score .battle_mode general matches 7 if score Red training >= .battle_max_score general if score .battle_ending_timer general matches 0 run function tmls:functions/matchmaking/modes/training/stop

##ending

execute if score .battle_ending_timer general matches 1.. run scoreboard players add .battle_ending_timer general 1


execute if score .battle_ending_timer general matches 120 run execute as @a[tag=ingame] at @s run function tmls:functions/sound-engine/stop/music3
execute if score .battle_ending_timer general matches 120 run execute as @a[tag=ingame] at @s run function tmls:functions/sound-engine/stop/music4
execute if score .battle_ending_timer general matches 120 run execute as @a[tag=ingame] at @s run function tmls:functions/sound-engine/stop/music5
execute if score .battle_ending_timer general matches 120 run execute as @a[tag=ingame] at @s run function tmls:functions/sound-engine/stop/music6
execute if score .battle_ending_timer general matches 120 run execute as @a[tag=ingame] at @s run function tmls:functions/sound-engine/stop/music7
execute if score .battle_ending_timer general matches 120 run execute as @a[tag=ingame] at @s run function tmls:functions/sound-engine/stop/music8
execute if score .battle_ending_timer general matches 120 run execute as @a[tag=ingame] at @s run function tmls:functions/sound-engine/stop/wind
execute if score .battle_ending_timer general matches 120 run execute as @a[tag=ingame] at @s run function tmls:functions/sound-engine/stop/birds
execute if score .battle_ending_timer general matches 120 run execute as @a[tag=ingame] at @s run function tmls:functions/sound-engine/stop/crickets
execute if score .battle_ending_timer general matches 120 run title @a[tag=ingame] times 20 20 20 
execute if score .battle_ending_timer general matches 120 run title @a[tag=ingame] title {"text":"\uE002"} 

execute if score .battle_ending_timer general matches 150 run tag @a[tag=ingame] add loading
execute if score .battle_ending_timer general matches 150 run gamemode spectator @a[tag=ingame]
execute if score .battle_ending_timer general matches 140 run tp @a[tag=ingame] -13 2 13 90 0
execute if score .battle_ending_timer general matches 171..210 run tp @a[tag=ingame] -13 2 13 90 0

execute if score .battle_ending_timer general matches 140 run kill @e[tag=bot]

execute if score .battle_ending_timer general matches 120 run scoreboard objectives setdisplay sidebar

execute if score .battle_ending_timer general matches 210 run title @a[tag=ingame] times 0 20 20 
execute if score .battle_ending_timer general matches 210 run title @a[tag=ingame] title {"text":"\uE002"} 
execute if score .battle_ending_timer general matches 211 run tp @a[tag=ingame] -13 16 10.75 0 0
execute if score .battle_ending_timer general matches 213..250 run tp @a[tag=ingame] -13 16 10.75 0 0

execute if score .battle_ending_timer general matches 2..250 run scoreboard players set @a[tag=ingame] Health 100

execute if score .battle_ending_timer general matches 250 run function tmls:functions/matchmaking/stop



##players count

scoreboard players set .battle_ingame_players_count general 0
execute as @a[tag=ingame] at @s run scoreboard players add .battle_ingame_players_count general 1

scoreboard players set .battle_team1_players_count general 0
execute if score .battle_mode general matches 2 as @a[tag=ingame,scores={team=1}] at @s run scoreboard players add .battle_team1_players_count general 1

scoreboard players set .battle_team2_players_count general 0
execute if score .battle_mode general matches 2 as @a[tag=ingame,scores={team=2}] at @s run scoreboard players add .battle_team2_players_count general 1



##stop if there are no players in the lobby/ if there's only one player/ if there's no players in one team

execute if score .battle_timer general matches 1.. if score .battle_started general matches 1 if score .battle_ingame_players_count general matches 1 unless entity @a[tag=spectator-ingame] unless score .battle_mode general matches 2 unless score .battle_mode general matches 4..5 unless score .battle_mode general matches 7 run scoreboard players operation @a[tag=ingame] score = .battle_max_score general


execute if score .battle_timer general matches 1.. if score .battle_started general matches 1 if score .battle_ingame_players_count general matches 1 unless entity @a[tag=spectator-ingame] if score .battle_mode general matches 2 if entity @a[scores={team=1},tag=ingame] run scoreboard players operation Red teamscore = .battle_max_score general
execute if score .battle_timer general matches 1.. if score .battle_started general matches 1 if score .battle_ingame_players_count general matches 1 unless entity @a[tag=spectator-ingame] if score .battle_mode general matches 2 if entity @a[scores={team=2},tag=ingame] run scoreboard players operation Blue teamscore = .battle_max_score general

execute if score .battle_timer general matches 1.. if score .battle_started general matches 1 if score .battle_ingame_players_count general matches 2.. unless entity @a[tag=spectator-ingame] if score .battle_mode general matches 2 unless entity @a[scores={team=2},tag=ingame] run scoreboard players operation Red teamscore = .battle_max_score general
execute if score .battle_timer general matches 1.. if score .battle_started general matches 1 if score .battle_ingame_players_count general matches 2.. unless entity @a[tag=spectator-ingame] if score .battle_mode general matches 2 unless entity @a[scores={team=1},tag=ingame] run scoreboard players operation Blue teamscore = .battle_max_score general



execute if score .battle_timer general matches 1.. if score .battle_started general matches 1 if score .battle_ingame_players_count general matches 1 unless entity @a[tag=spectator-ingame] if score .battle_mode general matches 4 if entity @a[scores={team=1},tag=ingame] run scoreboard players operation Red teamscore = .battle_max_score general
execute if score .battle_timer general matches 1.. if score .battle_started general matches 1 if score .battle_ingame_players_count general matches 1 unless entity @a[tag=spectator-ingame] if score .battle_mode general matches 4 if entity @a[scores={team=2},tag=ingame] run scoreboard players operation Blue teamscore = .battle_max_score general

execute if score .battle_timer general matches 1.. if score .battle_started general matches 1 if score .battle_ingame_players_count general matches 2.. unless entity @a[tag=spectator-ingame] if score .battle_mode general matches 4 unless entity @a[scores={team=2},tag=ingame] run scoreboard players operation Red teamscore = .battle_max_score general
execute if score .battle_timer general matches 1.. if score .battle_started general matches 1 if score .battle_ingame_players_count general matches 2.. unless entity @a[tag=spectator-ingame] if score .battle_mode general matches 4 unless entity @a[scores={team=1},tag=ingame] run scoreboard players operation Blue teamscore = .battle_max_score general

execute if score .battle_timer general matches 1.. if score .battle_started general matches 1 if score .battle_ingame_players_count general matches 1.. unless entity @a[tag=spectator-ingame] if score .battle_mode general matches 6 unless entity @a[scores={team=2},tag=ingame] run scoreboard players set Blue teamscore 0
execute if score .battle_timer general matches 1.. if score .battle_started general matches 1 if score .battle_ingame_players_count general matches 1.. unless entity @a[tag=spectator-ingame] if score .battle_mode general matches 6 unless entity @a[scores={team=1},tag=ingame] run scoreboard players set Red teamscore 0

execute if score .battle_timer general matches 1.. if score .battle_started general matches 1 if score .battle_mode general matches 5 unless entity @a[tag=spectator-ingame] unless entity @a[tag=undead] run scoreboard players operation Survivors infection = .battle_max_score general


##players particles

execute unless score .battle_mode general matches 1 unless score .battle_mode general matches 3 at @a[scores={team=1},tag=ingame] run particle minecraft:dust_color_transition 0.25 0 0 1 1 0 0 ~ ~2 ~ 0 0 0.1 0 1 force @a[scores={team=1,particles=1}]
execute unless score .battle_mode general matches 1 unless score .battle_mode general matches 3 at @a[scores={team=2},tag=ingame] run particle minecraft:dust_color_transition 0 0 0.25 1 0 0 1 ~ ~2 ~ 0 0 0.1 0 1 force @a[scores={team=2,particles=1}]